## curtin 21.3

=== Makefile ===
TOP := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
CWD := $(shell pwd)
PYTHON2 ?= python2
PYTHON3 ?= python3
COVERAGE ?= 1
DEFAULT_COVERAGEOPTS = --with-coverage --cover-erase --cover-branches --cover-package=curtin --cover-inclusive 
ifeq ($(COVERAGE), 1)
	coverageopts ?= $(DEFAULT_COVERAGEOPTS)
endif
CURTIN_VMTEST_IMAGE_SYNC ?= False
export CURTIN_VMTEST_IMAGE_SYNC
noseopts ?= -vv
pylintopts ?= --rcfile=pylintrc --errors-only
target_dirs ?= curtin tests tools

build:

bin/curtin: curtin/pack.py tools/write-curtin
	$(PYTHON) tools/write-curtin bin/curtin

check: unittest

style-check: pep8 pyflakes pyflakes3

coverage: coverageopts ?= $(DEFAULT_COVERAGEOPTS)
coverage: unittest

pep8:
	@$(CWD)/tools/run-pep8

pyflakes:
	$(PYTHON2) -m pyflakes $(target_dirs)

pyflakes3:
	$(PYTHON3) -m pyflakes $(target_dirs)

pylint:
	$(PYTHON2) -m pylint $(pylintopts) $(target_dirs)

pylint3:
	$(PYTHON3) -m pylint $(pylintopts) $(target_dirs)

unittest2:
	$(PYTHON2) -m nose $(coverageopts) $(noseopts) tests/unittests

unittest3:
	$(PYTHON3) -m nose $(coverageopts) $(noseopts) tests/unittests

unittest: unittest2 unittest3

schema-validate:
	@$(CWD)/tools/schema-validate-storage

docs: check-doc-deps
	make -C doc html

check-doc-deps:
	@which sphinx-build && $(PYTHON) -c 'import sphinx_rtd_theme' || \
		{ echo "Missing doc dependencies. Install with:"; \
		  pkgs="python3-sphinx-rtd-theme python3-sphinx"; \
		  echo sudo apt-get install -qy $$pkgs ; exit 1; }

# By default don't sync images when running all tests.
vmtest: schema-validate
	$(PYTHON3) -m nose $(noseopts) tests/vmtests

vmtest-deps:
	@$(CWD)/tools/vmtest-system-setup

sync-images:
	@$(CWD)/tools/vmtest-sync-images

integration-deps:
	@$(CWD)/tools/vmtest-create-static-images

integration: integration-deps
	$(PYTHON3) -m pytest tests/integration

clean:
	rm -rf doc/_build

.PHONY: all clean test pyflakes pyflakes3 pep8 build style-check check-doc-deps

=== requirements.txt ===
pyyaml
oauthlib
# For validation of storate configuration format
jsonschema
# Dependency of jsonschema.
# Version 0.16.0 is the latest version supporting Python < 3.5.
pyrsistent==0.16.0

=== debian/changelog ===
curtin (21.3-0ubuntu1) jammy; urgency=medium

  * New upstream release.
    - version to 21.3 [Dan Bungert] (LP: #1953410)
    - distro: handle ID_LIKE [Dan Bungert] (LP: #1934513)
    - block_meta: pass handlers dict to all handlers [Michael Hudson-Doyle]
    - block_meta: refactor partition verification slightly
      [Michael Hudson-Doyle]
    - block-meta: support using a raw image containing LVM volumes
      [Alexsander de Souza]
    - lsblk: adjust output to match old format [Dan Bungert]
    - curtin.commands.extract: Factor preparing sources for copying into a
      class [Michael Hudson-Doyle]
    - apt_config: tweaks to allow some functionality in partial tree as
      non-root [Michael Hudson-Doyle]
    - Add integration tests for some partitioning operations
      [Michael Hudson-Doyle]
    - command/apt: disable_components [Dan Bungert]
    - commands/apt: use python-apt for sources.list [Dan Bungert]
    - curthooks: always install shim-signed if available (when UEFI booted)
      [Michael Hudson-Doyle]
    - tox,control: fix jenkins CI jobs [Dan Bungert]
    - tests: update to demonstrate python-apt functional [Dan Bungert]
    - block:lvm: search encrypted volumes for LVM
      [Lukas Märdian] (LP: #1940687)
    - mdadm: allow installation to a syncing array
      [Michael Hudson-Doyle] (LP: #1939563)
    - vmtests: s/Groovy/Impish [Dan Bungert]
    - tweak making mountpoints private some more [Michael Hudson-Doyle]
    - curthooks: do not unconditionally copy e/n/interfaces to target
      [Michael Hudson-Doyle]
    - block: handle /dev/mapper/* in dev_path() [Lukas Märdian]
    - curthooks: do not add lvm devices filter when / is mutipathed
      [Michael Hudson-Doyle] (LP: #1895192)
    - Extend the 'format' schema for unknown fstypes [Dan Bungert]
    - move making mounts recursively private into do_unmount
      [Michael Hudson-Doyle]
    - disk_handler: fix partitioning a new RAID [Michael Hudson-Doyle]
    - curthooks:setup_zipl: use proper device path in root= arg for cmdline
      [Lukas Märdian]
    - fix tearing down ChrootableTarget when mounts appear while it is set up
      [Michael Hudson-Doyle] (LP: #1928839, #1934775)
    - Don't override PYTHON env var in bin/curtin [Dan Bungert]
    - disk_handler: check wipe field when deciding whether to reformat raids
      [Michael Hudson-Doyle] (LP: #1932976)
    - storage_config: properly handle raid containers [Michael Hudson-Doyle]
    - pylintrc: explicitly list the DISTROS generated-members [Paride Legovini]
    - block_meta: make preserve: true on a raid in a container work
      [Michael Hudson-Doyle]
    - Fix NVMe validation for namespaces with UUID
      [Ryan Norwood] (LP: #1925399)
    - meta_simple: handle multiple disks in storage config with dd-image
      [Dan Bungert] (LP: #1925722)
    - Use /proc/filesystems to decide passno
      [Dan Bungert] (LP: #1717584, LP: #1785354)
    - block_meta: fix wiping of existing dasd partition [Michael Hudson-Doyle]
    - block_meta: pass --yes to lvcreate alongside --wipesignatures=y
      [Michael Hudson-Doyle] (LP: #1923487)
    - remove 'strict' arguments to block.wipe_volume and block.quick_zero
      [Michael Hudson-Doyle] (LP: #1868177)
    - swap: use dd to allocate swapfiles on ext2 and ext3
      [Michael Hudson-Doyle] (LP: #1918990)
    - storage_config: return one type: disk action per multipathed disk
      [Michael Hudson-Doyle] (LP: #1893818)
    - vmtest/centos: handle different paths to grub config [Ryan Harper]

 -- Dan Bungert <daniel.bungert@canonical.com>  Mon, 06 Dec 2021 17:02:22 -0700

=== debian/control ===
Source: curtin
Section: admin
Priority: extra
Standards-Version: 3.9.6
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 7),
               dh-python,
               python3,
               python3-apt,
               python3-coverage,
               python3-mock,
               python3-nose,
               python3-oauthlib,
               python3-setuptools,
               python3-yaml
Homepage: http://launchpad.net/curtin
X-Python3-Version: >= 3.2

Package: curtin
Architecture: all
Priority: extra
Depends: bcache-tools,
         btrfs-progs | btrfs-tools,
         dosfstools,
         file,
         gdisk,
         lvm2,
         mdadm,
         parted,
         probert-storage | probert,
         python3-curtin (= ${binary:Version}),
         udev,
         xfsprogs,
         ${misc:Depends}
Description: Library and tools for the curtin installer
 This package provides the curtin installer.
 .
 Curtin is an installer that is blunt, brief, snappish, snippety and
 unceremonious.

Package: curtin-common
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Description: Library and tools for curtin installer
 This package contains utilities for the curtin installer.

Package: python3-curtin
Section: python
Architecture: all
Priority: extra
Depends: curtin-common (= ${binary:Version}),
         python3-apt,
         python3-oauthlib,
         python3-yaml,
         wget,
         ${misc:Depends},
         ${python3:Depends}
Description: Library and tools for curtin installer
 This package provides python3 library for use by curtin.

=== debian/rules ===
#!/usr/bin/make -f

PY3VERS := $(shell py3versions -r)

DEB_VERSION := $(shell dpkg-parsechangelog --show-field=Version)

%:
	dh $@ --with=python3

override_dh_auto_install:
	dh_auto_install
	set -ex; for python in $(PY3VERS); do \
		$$python setup.py build --executable=/usr/bin/python && \
		$$python setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
	done
	chmod 755 $(CURDIR)/debian/tmp/usr/lib/curtin/helpers/*
	for f in $$(find $(CURDIR)/debian/tmp/usr/lib -type f -name version.py); do [ -f "$$f" ] || continue; sed -i 's,@@PACKAGED_VERSION@@,$(DEB_VERSION),' "$$f"; done

override_dh_auto_test:
	make unittest3

override_dh_clean:
	dh_clean
	find . -name __pycache__ -exec rm -rf {} +

## curtin 22.1

=== debian/changelog ===
curtin (22.1-0ubuntu1) kinetic; urgency=medium

  * New upstream release. (LP: #1979687)
    - deb: fix dependencies [Dan Bungert]
    - tox: drop xenial-py3 from default env list [Dan Bungert]
    - block/v2: preserve disk label id [Dan Bungert]
    - block/v2: docs for partition_type [Dan Bungert]
    - block/v2: unit tests for partition_type [Dan Bungert]
    - block/v2: raw partition table codes for gpt [Dan Bungert]
    - block/v2: allow setting raw partition_type value [Dan Bungert]
    - Make sure curthooks do not discard supplied proxy settings
      [Olivier Gayot]
    - block/v2: resize-friendly ordering of wipe [Dan Bungert]
    - block/v2: handle resize when no format action [Dan Bungert]
    - block/v2: resize of ntfs [Dan Bungert]
    - vmtests: remove out of date skip [Dan Bungert]
    - block: provide get_resize_fstypes [Dan Bungert]
    - Add support for resize of ext{2,3,4} [Dan Bungert]
    - Add riscv64 to supported UEFI architectures [William Wilson]
    - block_meta_v2: call make_dname when required [Michael Hudson-Doyle]
    - examples: even more tweaks for v2 [Michael Hudson-Doyle]
    - Add riscv64 support [Heinrich Schuchardt]
    - examples: stop assuming curtin accounts for overhead of logical
      partitions [Michael Hudson-Doyle]
    - block_meta_v2: zero start of partitions before they are created
      [Michael Hudson-Doyle]
    - examples: enlarge / for some more vmtests [Michael Hudson-Doyle]
    - skip BionicTestPartitionExistingRAID.test_correct_ptype
      [Michael Hudson-Doyle]
    - examples: boost size of / in multipath-reuse.yaml [Michael Hudson-Doyle]
    - examples: add offsets to preserved partitions [Michael Hudson-Doyle]
    - block_meta_v2: change how we invoke sfdisk again, restore partprobe call
      [Michael Hudson-Doyle]
    - block_meta_v2: fix partitioning a device with sector size != 512
      [Michael Hudson-Doyle]
    - block_meta_v2: fix implicit offset calculation for dos partitions
      [Michael Hudson-Doyle]
    - block_meta_v2: do not use aliases for partition types
      [Michael Hudson-Doyle]
    - Remove CentOS 6 tests. [Michael Hudson-Doyle]
    - vmtests: boost the size of / in a few tests [Michael Hudson-Doyle]
    - examples: sleep after creating bcache device in preserve-bcache.yaml
      [Michael Hudson-Doyle]
    - vmtests: fix parted invocation in partition-existing-raid.yaml
      [Michael Hudson-Doyle]
    - vmtests: bump VM memory size to 2048 MiB for all tests
      [Michael Hudson-Doyle]
    - vmtests: drop assertion that clear-holders ran [Michael Hudson-Doyle]
    - block_meta_v2: a few more fixes for v2 partitioning
      [Michael Hudson-Doyle]
    - block_meta: call realpath on partition node returned by sfdisk
      [Michael Hudson-Doyle]
    - Add rocky linux as a RHEL-like variant [Dimitri John Ledkov]
    - Update pylint version in tox.ini [Michael Hudson-Doyle]
    - block_meta: implement v2 partitioning [Michael Hudson-Doyle]
    - Stop running CI against Python 2 [Michael Hudson-Doyle]
    - Make sure curthooks do not discard APT preferences [Olivier Gayot]
    - Remove leftover debug print statement [Olivier Gayot]
    - Fix format of examples/apt-source.yaml [Olivier Gayot]
    - Implement support for APT preferences in apt-config [Olivier Gayot]
    - build-deb: changelog gen with dch [Dan Bungert]
    - vmtests uefi: relax the uefi check [Dan Bungert]
    - block: output partition device path [Dan Bungert]
    - support version 2 curtin storage configs [Michael Hudson-Doyle]
    - system-upgrade: lookup os family [Dan Bungert]
    - add preserve: true support to the image action [Michael Hudson-Doyle]

 -- Dan Bungert <daniel.bungert@canonical.com>  Mon, 27 Jun 2022 16:24:54 -0600
